<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesAuthGroupProxy extends \Entities\AuthGroup implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function id()
    {
        $this->__load();
        return parent::id();
    }

    public function name($name = NULL)
    {
        $this->__load();
        return parent::name($name);
    }

    public function addPart(\Entities\Part $part)
    {
        $this->__load();
        return parent::addPart($part);
    }

    public function parts()
    {
        $this->__load();
        return parent::parts();
    }

    public function addTeacher(\Entities\Teacher $teacher)
    {
        $this->__load();
        return parent::addTeacher($teacher);
    }

    public function teachers()
    {
        $this->__load();
        return parent::teachers();
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'id', 'name', 'parts', 'teachers');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}